#include <download_manager.h>

#include <sys/ioctl.h>

#include <generic/acqprogress.h>

#include <sigc++/adaptors/bind.h>
#include <sigc++/functors/mem_fun.h>
#include <sigc++/functors/ptr_fun.h>

unsigned int screen_width=80;

void update_screen_width(int foo=0)
{
  // Ripped from apt-get, which ripped it from GNU ls
  winsize ws;

  if (ioctl(1, TIOCGWINSZ, &ws) != -1 && ws.ws_col >= 5)
    screen_width = ws.ws_col - 1;
}

static void dl_complete(download_manager &manager,
			AcqTextStatus *acqprogress)
{
  delete acqprogress;
}

download_manager *gen_cmdline_download_progress()
{
  download_manager *m=new download_manager;

  // FIXME: LEAK!!!!  (since the command-line stuff will only use this once
  // and then terminate, and killing this leak is a major pain, I'm
  // letting it by for now, but this MUST BE FIXED EVENTUALLY!)
  AcqTextStatus *acqprogress=new AcqTextStatus(screen_width, 0);

  m->MediaChange_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::MediaChange));
  m->IMSHit_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::IMSHit));
  m->Fetch_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Fetch));
  m->Done_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Done));
  m->Fail_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Fail));
  m->Pulse_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Pulse));
  m->Start_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Start));
  m->Stop_sig.connect(sigc::mem_fun(*acqprogress, &AcqTextStatus::Stop));
  m->Complete_sig.connect(sigc::bind(sigc::ptr_fun(dl_complete),
				     acqprogress));

  // FIXME: Maybe the AcqTextStatus should be deleted on Complete?
  //m->Complete_sig.connect(sigc::mem_fun(acqprogress, &AcqTextStatus::Complete));

  return m;
}

