// vs_frame.cc

#include "vs_frame.h"

#include "config/colors.h"

#include <sigc++/functors/mem_fun.h>

vs_frame::vs_frame(vscreen_widget *w)
  :vs_bin()
{
  set_subwidget(w);

  do_layout.connect(sigc::mem_fun(*this, &vs_frame::layout_me));
}

int vs_frame::width_request()
{
  if(get_subwidget() && get_subwidget()->get_visible())
    return get_subwidget()->width_request()+2;
  else
    return 2;
}

int vs_frame::height_request(int width)
{
  if(width<2)
    return 0;
  else if(get_subwidget() && get_subwidget()->get_visible())
    return get_subwidget()->height_request(width-2)+2;
  else
    return 2;
}

void vs_frame::layout_me()
{
  if(get_subwidget())
    {
      if(get_subwidget()->get_visible())
	get_subwidget()->alloc_size(1, 1, getmaxx()-2, getmaxy()-2);
      else
	get_subwidget()->alloc_size(0, 0, 0, 0);
    }
}

void vs_frame::paint(const style &st)
{
  border(0,0,0,0,0,0,0,0);

  if(get_subwidget() && get_subwidget()->get_visible())
    get_subwidget()->display(st);
}
