// vs_label.h          -*-c++-*-

#ifndef VS_LABEL_H
#define VS_LABEL_H

#include "vscreen_widget.h"

class fragment;
class fragment_cache;

class vs_label:public vscreen_widget
{
  fragment_cache *txt;
public:
  vs_label(fragment *f);
  vs_label(const std::string &_txt, const style &st);
  vs_label(const std::string &_txt);

  vs_label(const std::wstring &_txt, const style &st);
  vs_label(const std::wstring &_txt); 
 ~vs_label();

  bool get_cursorvisible();
  point get_cursorloc();

  /** \return the maximum width of any line in the label. */
  int width_request();

  /** \return the number of lines in the label. */
  int height_request(int width);

  void paint(const style &st);
  void set_text(const std::string &_txt, const style &st);
  void set_text(const std::string &_txt);
  void set_text(const std::wstring &_txt, const style &st);
  void set_text(const std::wstring &_txt);
  void set_text(fragment *f);
};

class vs_transientlabel:public vs_label
// Displays a transient message -- grabs the input focus and vanishes when a
// key is pressed.
{
protected:
  virtual bool handle_char(chtype ch);
public:
  vs_transientlabel(std::string msg, const style &st)
    :vs_label(msg, st)
  {
  }

  bool focus_me() {return true;}
};

#endif
